(* Berechnet die Primfaktorenzerlegung von n mit Hilfe
   des folgenden Algorithmus.
   -------- Algorithmus -----------------------------------
   Wiederhole...
     Falls n durch i (i=2,3,5,7,...) dividiert werden kann,
     notiere i und ersetze n durch n/i.
   ... bis n=1.
   Die notierten i's sind die Faktoren der PFZ.
   -------- Ende des Algorithmus ---------------------------
   Bsp.: n=4004
         i=2  n=2002
         i=2  n=2002
         i=7  n=143
         i=11 n=13
         i=13 n=1
   Also: 4004=2*2*7*11*13
   Eine Beschleunigung erreicht man durch folgende berlegung:
   Ist n=a*b so muss ein Faktor a oder b kleiner/gleich sqrt(n) sein.
   (Widerspuchsbeweis: a>sqrt(n) und b>sqrt(n) => a*b>n )
   Man braucht also nur mgliche Faktoren i<=sqrt(n) betrachten.
*)


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    BBerechne: TButton;
    Label1: TLabel;
    LPFZ: TLabel;
    Button1: TButton;
    ComboBox1: TComboBox;
    procedure BBerechneClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function PFZ(n:integer):string;
  var i:integer;
begin
  if n mod 2 = 0 then Begin
    result:='2*'+PFZ(n div 2);
    exit;
  End;
  for i:=1 to trunc(sqrt(n)) div 2 do     // 2i+1 = 3 ... sqrt(n) step 2
    if n mod (2*i+1) =0 then Begin
      result:=intToStr(2*i+1)+'*'+PFZ(n div (2*i+1));
      exit;
    End;
  result:=intToStr(n);
end;

function copyab(const s:string; const i:integer):string;
  //Rest von s ab i. em Zeichen
begin result:=copy(s,i,length(s)-i+1) end;


function ohneLeerzeichenf(const s:string):string;
   var n:integer;
begin
   result:=s;
   repeat
     n:=pos(' ',result);
     if n>0 then result:=copy(result,1,n-1)+copyab(result,n+1)
   until n=0;
end;

procedure TForm1.BBerechneClick(Sender: TObject);
  var n:integer;
      s:string;
begin
  n:=strToInt(ohneLeerzeichenf(combobox1.text));
  s:=PFZ(n);
  if pos('*',s)=0 then s:='Primzahl';
  LPFZ.caption:=s;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
 close
end;

procedure TForm1.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then Begin
    BBerechneClick(Nil);
    combobox1.SelectAll;
  End;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  LPFZ.caption:='';
end;

end.
